import com.patrac.model.entity.authenticate.User;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;

import java.util.List;
import java.util.logging.Logger;

/**
 * User: Patrick
 * Date: 7/14/12
 * Time: 12:14 AM
 */
public class BootstrapAdminPassword
{
    private Logger logger = Logger.getLogger(this.getClass().getName());

    public BootstrapAdminPassword() {}

    public static void main(String... args) throws Exception
    {
        BootstrapAdminPassword bootstrapAdminPassword = new BootstrapAdminPassword();
        System.out.println((bootstrapAdminPassword.execute()) ? "success" : "failure" );
    }

    public boolean execute() throws Exception
    {
        boolean result = true;
        SessionFactory sessionFactory = HibernateUtil.getSessionFactory();
        Session session = sessionFactory.openSession();
        Transaction transaction = null;
        try
        {
            transaction = session.beginTransaction();
            @SuppressWarnings("unchecked") List<User> users = session.createCriteria(User.class).list();
            for(User user : users)
            {
                user.saltPassword();
                session.merge(user);
            }
            transaction.commit();
        }
        catch(Exception e)
        {
            result = false;
            if(null != transaction) { transaction.rollback(); }
            throw e;
        }
        finally { session.close(); }
        return result;
    }
}
